Include		windows.inc
Include 	\masm32\macros\macros.asm

;-- MACROS
uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM

uselib gdi32
uselib masm32
uselib comdlg32
uselib kernel32
uselib comctl32
uselib user32

LOWORD MACRO DoubleWord
	mov	eax,DoubleWord
	and	eax,0FFFFh
ENDM

HIWORD MACRO DoubleWord
	mov	eax,DoubleWord
	shr	eax,16
ENDM

;-- PROTOTYPES
DlgProc		   PROTO :DWORD,:DWORD,:DWORD,:DWORD
DlgOptProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD
CmdStopProc    PROTO :DWORD,:DWORD,:DWORD,:DWORD
ControlMain    PROTO :DWORD,:DWORD
ControlED      PROTO :DWORD
DateTime2sz    PROTO :DWORD
InitMem        PROTO

;-- SETTINGS STRUCTURE
STA STRUCT
	dwSleep		DWORD ?		; delay time
	dwCBState	DWORD ?		; check status: BST_UNCHECKED or BST_CHECKED
	wFormatF 	WORD ?
	wFormatR	WORD ?
	szSleep     BYTE 4 DUP (?)
	szFileTitle BYTE MAX_PATH DUP (?)
	szFileName  BYTE MAX_PATH DUP (?)
STA EndS

;-- CONSTANTS
.CONST

;-- Messages
WM_FINISH       EQU WM_USER+100h

;-- Menu
IDM_MNU			EQU 100
IDM_FILE		EQU 110
IDM_EXIT		EQU 111
IDM_RUN			EQU 120
IDM_START		EQU 121
IDM_PAUSE		EQU 122
IDM_OPT			EQU 130

;-- Dialogs 'n Controls	
IDD_MAIN		EQU 1000
IDB_EXIT		EQU 1001
IDB_TEST		EQU 1002
IDC_GBFLAGS		EQU 1010
CB_CARRY		EQU 1011
CB_PARITY		EQU 1012
CB_AUXILIARY	EQU 1013
CB_ZERO			EQU 1014
CB_SIGN			EQU 1015
CB_TRAP			EQU 1016
CB_DIRECTION	EQU 1017
CB_OVERFLOW		EQU 1018
IDC_GBREG		EQU 1020
ST_EAX_TEXT		EQU 1022
ST_EBX_TEXT		EQU 1023
ST_ECX_TEXT		EQU 1024
ST_EDX_TEXT		EQU 1025
ST_ESP_TEXT		EQU 1026
ST_EBP_TEXT		EQU 1027
ST_ESI_TEXT		EQU 1028
ST_EDI_TEXT		EQU 1029
ST_ECX			EQU 1031
ST_EDX			EQU 1032
ST_EBX			EQU 1033
ST_ESP			EQU 1034
ST_EBP			EQU 1035
ST_ESI			EQU 1036
ST_EDI			EQU 1037
ST_EAX			EQU 1039
ST_STEP_TEXT	EQU 1040
IDB_STOP		EQU 1041
IDB_OPT			EQU 1042
IDD_DLGOPT		EQU 1044
IDB_CANCEL		EQU 1047
IDB_APPLY		EQU 1048
IDC_GBOPT		EQU 1049
IDB_FILE		EQU 1050
CB_FILE			EQU 1051
IDC_STATIC1052	EQU 1052
IDC_DELAY		EQU 1053
IDC_GBOPTOTHER	EQU 1054
IDC_STATIC1058	EQU 1058
IDC_PATH		EQU 1059
IDC_GBOPTREG	EQU 1061
RB_REGROW		EQU 1062
RB_REGCOL		EQU 1063
IDC_GBOPTFLAG	EQU 1064
RB_FLAGROW		EQU 1065
RB_FLAGCOL		EQU 1066

.DATA?
hInstance	    DWORD ?
hCtrl           DWORD ?
ThreadID        DWORD ?
hMenu           DWORD ?
pST             DWORD ? 	; pointer to STATUS struct
pSTcpy          DWORD ? 	; pointer to copy of STATUS struct (options dialog)
MII				MENUITEMINFO <?>

.DATA
bPFlag       	DWORD 0
hThread     	DWORD 0
szEmpty         BYTE "< no file selected >",0
szPause         BYTE "Pause",0
szCont          BYTE "Continue",0
