SzCpy_dw1 PROTO :DWORD,:DWORD

.DATA

align 4
String1     DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play ",0
String2     DB  128 dup(0)

.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

; This is a procedure coded by MichaelW, posted on masmforum.
; It copies a string...
; I did not understand the part testing for a zero byte,
; so i decided to have a deeper look at the results in
; the CPU-registers to see every instruction and the results....

SzCpy_dw1 proc uses ebx edi lpsrc:DWORD,lpdest:DWORD

    push  ebx
    mov   eax,[esp+8]           ; lpsrc
    mov   edx,[esp+12]          ; lpdest
    align 4
  @@:
    REPEAT 8                    ; unroll x 8
      mov ebx,[eax]           ; get next 4 bytes
      RegFlag SADD(" 1: mov ebx,[eax]")
      add eax,4
      RegFlag SADD(" 2: add eax,4")
      lea ecx,[ebx-01010101h] ; subtract 1 from each byte
      RegFlag SADD(" 3: lea ecx,[ebx-01010101h]")
      not ebx                 ; invert all bytes
      RegFlag SADD(" 4: not ebx") 
      and ecx,ebx             ; and each byte with inversion
      RegFlag SADD(" 5: and ecx,ebx")
      not   ebx                 ; restore bytes
      RegFlag SADD(" 6: not ebx")
      and ecx,80808080h       ; bytes=80h for null,otherwise 0
      RegFlag SADD(" 7: and ecx,80808080h")
      jnz   @F                  ; jump if zero byte present
      mov [edx],ebx           ; copy 4 bytes
      RegFlag SADD(" 8: mov [edx],ebx")
      add edx,4
      RegFlag SADD(" 9: add edx,4")
    ENDM
    jmp   @B
  @@:
    mov   [edx],bl              ; move first byte
    add   edx,1
    test  bl,bl
    jz    @F                    ; jump if was null
    mov   [edx],bh              ; move next byte
    add   edx,1
    test  bh,bh
    jz    @F                    ; jump if was null
    shr   ebx,16
    mov   [edx],bl              ; move next byte
    add   edx,1
    test  bl,bl
    jz    @F                    ; jump if was null
    mov   [edx],bh              ; move last byte
  @@:
    mov   eax,edx               ; return length w/o null
    sub   eax,[esp+12]          ; lpdest

    pop   ebx
    ret   8
    
SzCpy_dw1 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef